TITLE Executa.asm
;                                      ====================
;=======================================   Executa.asm    ==========================================
;==                                    ====================                                       ==
;==                                                                                               ==
;== Project         : ScanGui                                                                     ==
;== Filename        : Executa.asm                                                                 ==
;== Version         : 1                                                                           ==
;== Date            : Jul 15, 2008                                                                 ==
;== Compiler        : Masm v. 6.14 by Microsoft Corporation.                                      ==
;== Purpose         : Runs scan.exe with correct command line and generates an imported functions ==
;==                   file.                                                                       ==
;==                                                                                               ==
;===================================================================================================
;==                                                                                               ==
;== Copyright (c) 2008, P. H. Duarte                                                              ==
;== All rights reserved.                                                                          ==
;==                                                                                               ==
;===================================================================================================

; VERSION HISTORY:
; ----------------

; Version           : 1
; Date              : Jul 15, 2008
; Revised by        : P. H. Duarte
; Description       : Original Version.
;===================================================================================================

.686
.model flat, stdcall
option casemap:none
PUBLIC Executa

;===================================================================================================
;=                                    Include Files                                                =
;===================================================================================================

include ScanGII.inc

;===================================================================================================
;=                                    Local Data                                                   =
;===================================================================================================

.data
sat		  	SECURITY_ATTRIBUTES <SIZEOF SECURITY_ATTRIBUTES, NULL, TRUE>

.data?

StartInfo 	STARTUPINFO			<?>
ProcInfo  	PROCESS_INFORMATION	<?>

;===================================================================================================

.code	

;================================================================================
;
; Executa (hwnd, lpLine)
;
; PURPOSE:	Executes scan.exe with correct command line.
;
; ENTRY:	hwnd	= Handle to the main program window.

; EXIT:		EAX holds a message:
;			ID_ST_NOPIPEALLOWED		= Can't create pipe.
;			ID_ST_NOPROCESSCREATED	= Can't execute scan.exe.
;			ID_ST_SUCESS			= Successfull operation.
;
; Important remark: I followed the Iczellion tutorial n. 21: PIPE.
;==================================================================================

Executa proc hwnd:HWND, lpLine:DWORD

LOCAL hReadPipe:DWORD		;	Handle to the read end of the pipe.
LOCAL hWritePipe:DWORD		;	Handle to the write end of the pipe.
LOCAL cBytesRead:DWORD		;   Pointer to the real number of read bytes from ReadFile API.
LOCAL hWarn:DWORD			;	Handle to EDT_3 (warning messages).
LOCAL szbuffer[1024]:TCHAR	; 	Holds pipe messages.
	
	invoke GetDlgItem, dword ptr ds:[hwnd], EDT_3
	mov dword ptr ds:[hWarn], EAX
	invoke SetDlgItemText, dword ptr ds:[hwnd], EDT_3, NULL ; Cleans warning area.
	
; --> Create pipeline to communicate with scan.exe. <--
	
	invoke CreatePipe, addr hReadPipe, addr hWritePipe, addr sat, 0
	.if EAX == 0
		mov EAX, ID_ST_NOPIPEALLOWED
		jmp SAI
	.endif
	mov	dword ptr ds:[StartInfo.cb], SIZEOF STARTUPINFO
	
; --> Initialize structure StartInfo. <-- 
	
	invoke GetStartupInfo, offset StartInfo
	mov EAX, dword ptr ds: dword ptr ds:[hWritePipe]
	mov dword ptr ds:[StartInfo.hStdOutput], EAX
	mov dword ptr ds:[StartInfo.hStdError], EAX
	mov dword ptr ds:[StartInfo.dwFlags], STARTF_USESHOWWINDOW + STARTF_USESTDHANDLES
	mov dword ptr ds:[StartInfo.wShowWindow], SW_HIDE
	
; --> Run Scan.exe. <--
	
	invoke CreateProcess, 
					NULL, 
					dword ptr ds:[lpLine], 
					NULL, 
					NULL, 
					TRUE, 
					HIGH_PRIORITY_CLASS, 
					NULL, 
					NULL, 
					addr StartInfo, 
					addr ProcInfo
	
; --> Verify error or success! <-- 
	
	.if EAX == 0
		mov EAX, ID_ST_NOPROCESSCREATED	;	EAX -> Impossible to create a process.
;		jmp SAI
	.else
		invoke CloseHandle, dword ptr ds:[ProcInfo.hThread]
		invoke CloseHandle, dword ptr ds:[ProcInfo.hProcess]
		invoke CloseHandle, dword ptr ds:[hWritePipe]
		.while TRUE
			invoke RtlZeroMemory, addr szbuffer, 1024
			invoke ReadFile, dword ptr ds:[hReadPipe], addr szbuffer, sizeof szbuffer - 1, \
			addr cBytesRead, NULL
			.break .if (!EAX)
			
; --> Show scan.exe error messages.
			
			invoke SendMessage, dword ptr ds:[hWarn], EM_SETSEL, -1, 0
			invoke SendMessage, dword ptr ds:[hWarn], EM_REPLACESEL, \
			FALSE, addr szbuffer
		.endw
	.endif
	invoke CloseHandle, dword ptr ds:[hReadPipe]
	invoke GetDlgItemText, dword ptr ds:[hwnd], EDT_3, addr szbuffer, MAXLEN	
	.if EAX == 0
		mov EAX, ID_ST_SUCESS
	
	.else
		mov EAX, ID_ST_ERROR_SCANNER
	.endif
	
SAI:
	ret
Executa endp
end
;===================================================================================================
;=                                         EOF                                                     =
;===================================================================================================