;                                      ====================
;=======================================  Messagier.asm   ==========================================
;==                                    ====================                                       ==
;==                                                                                               ==
;== Project         : ScanGui                                                                     ==
;== Filename        : Messagier.asm                                                               ==
;== Version         : 1                                                                           ==
;== Date            : Jul 15, 2008                                                                 ==
;== Compiler        : Masm v. 6.14 by Microsoft Corporation.                                      ==
;== Purpose         : Show message box with information to user.                                  ==
;==                                                                                               ==
;===================================================================================================
;==                                                                                               ==
;== Copyright (c) 2008, P. H. Duarte                                                              ==
;== All rights reserved.                                                                          ==
;==                                                                                               ==
;===================================================================================================

; VERSION HISTORY:
; ----------------

; Version           : 1
; Date              : Jul 15, 2008
; Revised by        : P. H. Duarte
; Description       : Original Version.
;===================================================================================================

.686
.model flat, stdcall
option casemap:none

;===================================================================================================
;=                                     Exported Symbols and functions                              =
;===================================================================================================

PUBLIC	MessagierProc

;===================================================================================================
;=                                     Include Files                                               =
;===================================================================================================

include ScanGII.inc

;===================================================================================================
.code

;================================================================================
;
; MessagierProc (ID_Caption, ID_Message, lmptypeID)
;
; PURPOSE:	To show a MessageBox to user.
;
; ENTRY:	ID_Caption     = ID to message type (error, warning etc).
;			ID_Message     = Message ID.
;			lmptypeID      = MessageBox type.
;
;			Uses szlocalbuffer to holds the message.
;
; EXIT:		No significative values..
;
;==================================================================================

MessagierProc	PROC STDCALL, ID_Caption:UINT, ID_Message:DWORD, lpmtypeID:DWORD
align 04
LOCAL szlocalbuffer[MAXLEN]:BYTE
	
	invoke RtlZeroMemory, addr szlocalbuffer, MAXLEN
	invoke LoadString, 
				dword ptr ds:[hInstance], 
				dword ptr ds:[ID_Message], 
				addr szlocalbuffer, 
				MAXLEN
	
	invoke MessageBox, 
				NULL, 
				addr szlocalbuffer, 
				dword ptr ds:[ID_Caption], 
				dword ptr ds:[lpmtypeID]
	ret
MessagierProc ENDP
end
;===================================================================================================
;=                                             EOF                                                 =
;===================================================================================================