;                                      ====================
;======================================= Montalinha.asm   ==========================================
;==                                    ====================                                       ==
;==                                                                                               ==
;== Project         : ScanGui                                                                     ==
;== Filename        : Montalinha.asm                                                              ==
;== Version         : 2                                                                           ==
;== Date            : Jul 15, 2008                                                                 ==
;== Compiler        : Masm v. 6.14 by Microsoft Corporation.                                      ==
;== Purpose         :                                                                             ==
;==                                                                                               ==
;===================================================================================================
;==                                                                                               ==
;== Copyright (c) 2008, P. H. Duarte                                                              ==
;== All rights reserved.                                                                          ==
;==                                                                                               ==
;===================================================================================================

; VERSION HISTORY:
; ----------------

; Version           : 2
; Date              : Jul 15, 2008
; Revised by        : P. H. Duarte
; Description       : Corrected bug on line generation.
;					  Changed command line generation strings.
;                     Uses EDI to return values.
;===================================================================================================

.686
.model flat, stdcall
option casemap:none

;===================================================================================================
;=                                     Exported Symbols and functions                              =
;===================================================================================================

PUBLIC	MontaLinha
PUBLIC	lpstrFilePath
PUBLIC	bOptions
PUBLIC	lpstrScanCmdLine

;===================================================================================================
;=                                     Include Files                                               =
;===================================================================================================
MONTALINHA = 1
include ScanGII.inc

;===================================================================================================
;=                                     Local Data                                                  =
;===================================================================================================

.data
szOutFormat			TCHAR	"  -f -f2  -g  -a -dc -ic -go -g2  -m -m2 -m3 -m4 -m5 -m6 -m7"
					TCHAR	"  -t -l2 -l3 -na  -h  -p", 0
szOptUnicode		TCHAR	" -w ", 0
szOptCase			TCHAR	" -is", 0
szNoWarnings		TCHAR	" -n", 0
szOptName			TCHAR	" -o:", 0
szScan				TCHAR	"scan.exe ", 0	; Program to run.
szSpace				TCHAR	" ", 0			; Space!!!
align 02
lpstrScanCmdLine	TCHAR	MAXLEN		DUP(0)
align 02
lpstrFilePath		TCHAR	MAXLEN		DUP(0)
align 02
bOptions			BOOLEAN	3			DUP(0) ; Other options.

;===================================================================================================
.code	

;===================================================================================================
;
; Montalinha (hwnd)
;
; PURPOSE:	Create the command line to Scan.exe
;
; ENTRY:	hwnd	= Handle to main window.	
;
; EXIT:		EDI holds the command line address.
;
;===================================================================================================

MontaLinha	proc hwnd:HWND
align 04
	
	invoke RtlZeroMemory, addr lpstrScanCmdLine, MAXLEN		; Cleans the command line for scan.exe
	invoke SendMessage, dword ptr ds:[hCombo], CB_GETCURSEL, NULL, NULL  
	shl EAX, 02											 
	add EAX, offset szOutFormat			
	xchg EAX, ESI						; ESI -> Choosed compiler.
	push offset lpstrScanCmdLine
	pop EDI
	invoke lstrlen, addr szScanPath		; Verifies scan.exe path.
	.if EAX
		invoke lstrcat, EDI, addr szScanPath
		invoke lstrcat, EDI, addr szSpace
	.else
		invoke lstrcat, EDI, addr szScan
	.endif
	invoke lstrcat, EDI, addr lpstrFile
	
; --> Choosed compilator. <-- 
	
	invoke lstrlen, EDI
	push EDI
	add EDI, EAX
	mov ECX, 04 
	cld
	rep movsb
	
; --> Add source file name. <-- 
	
	pop EDI
	for concaten, <szOptName, lpstrFilePath> 
		invoke lstrcat, EDI, addr concaten 
	endm
	
; --> Add importations file name <-- 
	
	invoke GetDlgItemText, dword ptr ds:[hwnd], EDT_2, addr szOutName, MAXLEN
	invoke lstrcat, EDI, addr szOutName
	
; --> Add other options ( Unicode, No warnings ... ). <-- 	
	
	optpointer = 0
	for concateno, <szOptUnicode, szOptCase, szNoWarnings>
		.if byte ptr ds:[bOptions + optpointer] == 1
			invoke lstrcat, EDI, addr concateno
		.endif
		optpointer = optpointer + 1
	endm
	ret
MontaLinha	endp
end
;===================================================================================================
;=                                             EOF                                                 =
;===================================================================================================