TITLE StartCombo.asm

;                                      ====================
;======================================= StartCombo.asm   ==========================================
;==                                    ====================                                       ==
;==                                                                                               ==
;== Project         : ScanGui                                                                     ==
;== Filename        : StartCombo.asm                                                              ==
;== Version         : 1                                                                           ==
;== Date            : Jul 15, 2008                                                                 ==
;== Compiler        : Masm v. 6.14 by Microsoft Corporation.                                      ==
;== Purpose         : Initializes the program combo box with compiler options.                    ==
;==                                                                                               ==
;===================================================================================================
;==                                                                                               ==
;== Copyright (c) 2008, P. H. Duarte                                                              ==
;== All rights reserved.                                                                          ==
;==                                                                                               ==
;===================================================================================================

; VERSION HISTORY:
; ----------------

; Version           : 1
; Date              : Jul 15, 2008
; Revised by        : P. H. Duarte
; Description       : Original Version.
;===================================================================================================

.686
.model flat, stdcall
option casemap:none

;===================================================================================================
;=                                     Exported Symbols and functions                              =
;===================================================================================================

PUBLIC StartCombo

;===================================================================================================
;=                                  Include Files                                                  =
;===================================================================================================

include ScangII.inc

;===================================================================================================
;=                                 Local Data                                                      =
;===================================================================================================

.data
; ---> Compiler table and options.  <---
align 02
szFasm						TCHAR	"Fasm", 0
szFasm2						TCHAR	"Fasm =2", 0
szFasmGO					TCHAR	"Fasm + Golink", 0
szFasmAl					TCHAR	"Fasm + Alink", 0
szFasmMSD					TCHAR	"Fasm + Polink(direct)", 0
szFasmMSI					TCHAR	"Fasm + Polink(indirect)", 0
szGOasm						TCHAR	"Goasm", 0
szGOasm2					TCHAR	"Goasm  =2", 0
szMasm						TCHAR	"Masm   =1", 0						
szMasm2						TCHAR	"Masm   =2", 0
szMasm3						TCHAR	"Masm   =3", 0
szMasm4						TCHAR	"Masm   =4", 0
szMasm5						TCHAR	"Masm   =5", 0
szMasm6						TCHAR	"Masm   =6", 0
szMasm7 					TCHAR	"Masm   =7", 0
szTasm						TCHAR	"Tasm/LzAsm", 0
szLzAsm						TCHAR	"LzAsm =2", 0
szLzAsm3					TCHAR 	"LzAsm =3", 0 
szNasm						TCHAR	"NASM", 0
szHLA						TCHAR	"HLA", 0
szLibMod					TCHAR	"Library Modules", 0

align 04
dwTypeTable					DWORD	szFasm, szFasm2, szFasmGO, szFasmAl, szFasmMSD, szFasmMSI, szGOasm, 
									szGOasm2, szMasm, szMasm2, szMasm3, szMasm4, szMasm5, szMasm6, szMasm7, 
									szTasm, szLzAsm, szLzAsm3, szNasm, szHLA, szLibMod

;===================================================================================================			

.code	

;===================================================================================================
;
; Function StartCombo (hwnd)
;
; PURPOSE:	Initializes the combo box of application.
;
; ENTRY:	NA.
;
; EXIT:		No significative values.
;===================================================================================================

StartCombo proc hwnd:HWND
	align 04
	xor EBX, EBX 
	.while EBX < lengthof dwTypeTable 	; EBX -> compiler table.
		invoke SendMessage, 
						dword ptr ds:[hCombo], 
						CB_ADDSTRING, 
						0, 
						dword ptr ds:[dwTypeTable][EBX*04]
					 	
		inc EBX	
	.endw
	invoke SendMessage, 
					dword ptr ds:[hCombo], 
					CB_SETCURSEL, 
					0, 
					0
	ret
StartCombo endp
end
;===================================================================================================
;=                                             EOF                                                 =
;===================================================================================================